# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Slides.V1.Model.BatchUpdatePresentationResponse do
  @moduledoc """
  Response message from a batch update.

  ## Attributes

  *   `presentationId` (*type:* `String.t`, *default:* `nil`) - The presentation the updates were applied to.
  *   `replies` (*type:* `list(GoogleApi.Slides.V1.Model.Response.t)`, *default:* `nil`) - The reply of the updates. This maps 1:1 with the updates, although replies to some requests may be empty.
  *   `writeControl` (*type:* `GoogleApi.Slides.V1.Model.WriteControl.t`, *default:* `nil`) - The updated write control after applying the request.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :presentationId => String.t() | nil,
          :replies => list(GoogleApi.Slides.V1.Model.Response.t()) | nil,
          :writeControl => GoogleApi.Slides.V1.Model.WriteControl.t() | nil
        }

  field(:presentationId)
  field(:replies, as: GoogleApi.Slides.V1.Model.Response, type: :list)
  field(:writeControl, as: GoogleApi.Slides.V1.Model.WriteControl)
end

defimpl Poison.Decoder, for: GoogleApi.Slides.V1.Model.BatchUpdatePresentationResponse do
  def decode(value, options) do
    GoogleApi.Slides.V1.Model.BatchUpdatePresentationResponse.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Slides.V1.Model.BatchUpdatePresentationResponse do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
