# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Slides.V1.Model.ColorStop do
  @moduledoc """
  A color and position in a gradient band.

  ## Attributes

  *   `alpha` (*type:* `number()`, *default:* `nil`) - The alpha value of this color in the gradient band. Defaults to 1.0, fully opaque.
  *   `color` (*type:* `GoogleApi.Slides.V1.Model.OpaqueColor.t`, *default:* `nil`) - The color of the gradient stop.
  *   `position` (*type:* `number()`, *default:* `nil`) - The relative position of the color stop in the gradient band measured in percentage. The value should be in the interval [0.0, 1.0].
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :alpha => number() | nil,
          :color => GoogleApi.Slides.V1.Model.OpaqueColor.t() | nil,
          :position => number() | nil
        }

  field(:alpha)
  field(:color, as: GoogleApi.Slides.V1.Model.OpaqueColor)
  field(:position)
end

defimpl Poison.Decoder, for: GoogleApi.Slides.V1.Model.ColorStop do
  def decode(value, options) do
    GoogleApi.Slides.V1.Model.ColorStop.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Slides.V1.Model.ColorStop do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
