# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Slides.V1.Model.CreateShapeRequest do
  @moduledoc """
  Creates a new shape.

  ## Attributes

  *   `elementProperties` (*type:* `GoogleApi.Slides.V1.Model.PageElementProperties.t`, *default:* `nil`) - The element properties for the shape.
  *   `objectId` (*type:* `String.t`, *default:* `nil`) - A user-supplied object ID. If you specify an ID, it must be unique among all pages and page elements in the presentation. The ID must start with an alphanumeric character or an underscore (matches regex `[a-zA-Z0-9_]`); remaining characters may include those as well as a hyphen or colon (matches regex `[a-zA-Z0-9_-:]`). The length of the ID must not be less than 5 or greater than 50. If empty, a unique identifier will be generated.
  *   `shapeType` (*type:* `String.t`, *default:* `nil`) - The shape type.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :elementProperties => GoogleApi.Slides.V1.Model.PageElementProperties.t() | nil,
          :objectId => String.t() | nil,
          :shapeType => String.t() | nil
        }

  field(:elementProperties, as: GoogleApi.Slides.V1.Model.PageElementProperties)
  field(:objectId)
  field(:shapeType)
end

defimpl Poison.Decoder, for: GoogleApi.Slides.V1.Model.CreateShapeRequest do
  def decode(value, options) do
    GoogleApi.Slides.V1.Model.CreateShapeRequest.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Slides.V1.Model.CreateShapeRequest do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
