# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Slides.V1.Model.CreateTableRequest do
  @moduledoc """
  Creates a new table.

  ## Attributes

  *   `columns` (*type:* `integer()`, *default:* `nil`) - Number of columns in the table.
  *   `elementProperties` (*type:* `GoogleApi.Slides.V1.Model.PageElementProperties.t`, *default:* `nil`) - The element properties for the table. The table will be created at the provided size, subject to a minimum size. If no size is provided, the table will be automatically sized. Table transforms must have a scale of 1 and no shear components. If no transform is provided, the table will be centered on the page.
  *   `objectId` (*type:* `String.t`, *default:* `nil`) - A user-supplied object ID. If you specify an ID, it must be unique among all pages and page elements in the presentation. The ID must start with an alphanumeric character or an underscore (matches regex `[a-zA-Z0-9_]`); remaining characters may include those as well as a hyphen or colon (matches regex `[a-zA-Z0-9_-:]`). The length of the ID must not be less than 5 or greater than 50. If you don't specify an ID, a unique one is generated.
  *   `rows` (*type:* `integer()`, *default:* `nil`) - Number of rows in the table.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :columns => integer() | nil,
          :elementProperties => GoogleApi.Slides.V1.Model.PageElementProperties.t() | nil,
          :objectId => String.t() | nil,
          :rows => integer() | nil
        }

  field(:columns)
  field(:elementProperties, as: GoogleApi.Slides.V1.Model.PageElementProperties)
  field(:objectId)
  field(:rows)
end

defimpl Poison.Decoder, for: GoogleApi.Slides.V1.Model.CreateTableRequest do
  def decode(value, options) do
    GoogleApi.Slides.V1.Model.CreateTableRequest.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Slides.V1.Model.CreateTableRequest do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
