# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Slides.V1.Model.DeleteParagraphBulletsRequest do
  @moduledoc """
  Deletes bullets from all of the paragraphs that overlap with the given text index range. The nesting level of each paragraph will be visually preserved by adding indent to the start of the corresponding paragraph.

  ## Attributes

  *   `cellLocation` (*type:* `GoogleApi.Slides.V1.Model.TableCellLocation.t`, *default:* `nil`) - The optional table cell location if the text to be modified is in a table cell. If present, the object_id must refer to a table.
  *   `objectId` (*type:* `String.t`, *default:* `nil`) - The object ID of the shape or table containing the text to delete bullets from.
  *   `textRange` (*type:* `GoogleApi.Slides.V1.Model.Range.t`, *default:* `nil`) - The range of text to delete bullets from, based on TextElement indexes.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :cellLocation => GoogleApi.Slides.V1.Model.TableCellLocation.t() | nil,
          :objectId => String.t() | nil,
          :textRange => GoogleApi.Slides.V1.Model.Range.t() | nil
        }

  field(:cellLocation, as: GoogleApi.Slides.V1.Model.TableCellLocation)
  field(:objectId)
  field(:textRange, as: GoogleApi.Slides.V1.Model.Range)
end

defimpl Poison.Decoder, for: GoogleApi.Slides.V1.Model.DeleteParagraphBulletsRequest do
  def decode(value, options) do
    GoogleApi.Slides.V1.Model.DeleteParagraphBulletsRequest.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Slides.V1.Model.DeleteParagraphBulletsRequest do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
