# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Slides.V1.Model.GroupObjectsRequest do
  @moduledoc """
  Groups objects to create an object group. For example, groups PageElements to create a Group on the same page as all the children.

  ## Attributes

  *   `childrenObjectIds` (*type:* `list(String.t)`, *default:* `nil`) - The object IDs of the objects to group. Only page elements can be grouped. There should be at least two page elements on the same page that are not already in another group. Some page elements, such as videos, tables and placeholders cannot be grouped.
  *   `groupObjectId` (*type:* `String.t`, *default:* `nil`) - A user-supplied object ID for the group to be created. If you specify an ID, it must be unique among all pages and page elements in the presentation. The ID must start with an alphanumeric character or an underscore (matches regex `[a-zA-Z0-9_]`); remaining characters may include those as well as a hyphen or colon (matches regex `[a-zA-Z0-9_-:]`). The length of the ID must not be less than 5 or greater than 50. If you don't specify an ID, a unique one is generated.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :childrenObjectIds => list(String.t()) | nil,
          :groupObjectId => String.t() | nil
        }

  field(:childrenObjectIds, type: :list)
  field(:groupObjectId)
end

defimpl Poison.Decoder, for: GoogleApi.Slides.V1.Model.GroupObjectsRequest do
  def decode(value, options) do
    GoogleApi.Slides.V1.Model.GroupObjectsRequest.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Slides.V1.Model.GroupObjectsRequest do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
