# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Slides.V1.Model.LayoutReference do
  @moduledoc """
  Slide layout reference. This may reference either: - A predefined layout - One of the layouts in the presentation.

  ## Attributes

  *   `layoutId` (*type:* `String.t`, *default:* `nil`) - Layout ID: the object ID of one of the layouts in the presentation.
  *   `predefinedLayout` (*type:* `String.t`, *default:* `nil`) - Predefined layout.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :layoutId => String.t() | nil,
          :predefinedLayout => String.t() | nil
        }

  field(:layoutId)
  field(:predefinedLayout)
end

defimpl Poison.Decoder, for: GoogleApi.Slides.V1.Model.LayoutReference do
  def decode(value, options) do
    GoogleApi.Slides.V1.Model.LayoutReference.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Slides.V1.Model.LayoutReference do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
