# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Slides.V1.Model.LineProperties do
  @moduledoc """
  The properties of the Line. When unset, these fields default to values that match the appearance of new lines created in the Slides editor.

  ## Attributes

  *   `dashStyle` (*type:* `String.t`, *default:* `nil`) - The dash style of the line.
  *   `endArrow` (*type:* `String.t`, *default:* `nil`) - The style of the arrow at the end of the line.
  *   `endConnection` (*type:* `GoogleApi.Slides.V1.Model.LineConnection.t`, *default:* `nil`) - The connection at the end of the line. If unset, there is no connection. Only lines with a Type indicating it is a "connector" can have an `end_connection`.
  *   `lineFill` (*type:* `GoogleApi.Slides.V1.Model.LineFill.t`, *default:* `nil`) - The fill of the line. The default line fill matches the defaults for new lines created in the Slides editor.
  *   `link` (*type:* `GoogleApi.Slides.V1.Model.Link.t`, *default:* `nil`) - The hyperlink destination of the line. If unset, there is no link.
  *   `startArrow` (*type:* `String.t`, *default:* `nil`) - The style of the arrow at the beginning of the line.
  *   `startConnection` (*type:* `GoogleApi.Slides.V1.Model.LineConnection.t`, *default:* `nil`) - The connection at the beginning of the line. If unset, there is no connection. Only lines with a Type indicating it is a "connector" can have a `start_connection`.
  *   `weight` (*type:* `GoogleApi.Slides.V1.Model.Dimension.t`, *default:* `nil`) - The thickness of the line.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :dashStyle => String.t() | nil,
          :endArrow => String.t() | nil,
          :endConnection => GoogleApi.Slides.V1.Model.LineConnection.t() | nil,
          :lineFill => GoogleApi.Slides.V1.Model.LineFill.t() | nil,
          :link => GoogleApi.Slides.V1.Model.Link.t() | nil,
          :startArrow => String.t() | nil,
          :startConnection => GoogleApi.Slides.V1.Model.LineConnection.t() | nil,
          :weight => GoogleApi.Slides.V1.Model.Dimension.t() | nil
        }

  field(:dashStyle)
  field(:endArrow)
  field(:endConnection, as: GoogleApi.Slides.V1.Model.LineConnection)
  field(:lineFill, as: GoogleApi.Slides.V1.Model.LineFill)
  field(:link, as: GoogleApi.Slides.V1.Model.Link)
  field(:startArrow)
  field(:startConnection, as: GoogleApi.Slides.V1.Model.LineConnection)
  field(:weight, as: GoogleApi.Slides.V1.Model.Dimension)
end

defimpl Poison.Decoder, for: GoogleApi.Slides.V1.Model.LineProperties do
  def decode(value, options) do
    GoogleApi.Slides.V1.Model.LineProperties.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Slides.V1.Model.LineProperties do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
