# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Slides.V1.Model.NotesProperties do
  @moduledoc """
  The properties of Page that are only relevant for pages with page_type NOTES.

  ## Attributes

  *   `speakerNotesObjectId` (*type:* `String.t`, *default:* `nil`) - The object ID of the shape on this notes page that contains the speaker notes for the corresponding slide. The actual shape may not always exist on the notes page. Inserting text using this object ID will automatically create the shape. In this case, the actual shape may have different object ID. The `GetPresentation` or `GetPage` action will always return the latest object ID.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :speakerNotesObjectId => String.t() | nil
        }

  field(:speakerNotesObjectId)
end

defimpl Poison.Decoder, for: GoogleApi.Slides.V1.Model.NotesProperties do
  def decode(value, options) do
    GoogleApi.Slides.V1.Model.NotesProperties.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Slides.V1.Model.NotesProperties do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
