# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Slides.V1.Model.OptionalColor do
  @moduledoc """
  A color that can either be fully opaque or fully transparent.

  ## Attributes

  *   `opaqueColor` (*type:* `GoogleApi.Slides.V1.Model.OpaqueColor.t`, *default:* `nil`) - If set, this will be used as an opaque color. If unset, this represents a transparent color.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :opaqueColor => GoogleApi.Slides.V1.Model.OpaqueColor.t() | nil
        }

  field(:opaqueColor, as: GoogleApi.Slides.V1.Model.OpaqueColor)
end

defimpl Poison.Decoder, for: GoogleApi.Slides.V1.Model.OptionalColor do
  def decode(value, options) do
    GoogleApi.Slides.V1.Model.OptionalColor.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Slides.V1.Model.OptionalColor do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
