# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Slides.V1.Model.PageProperties do
  @moduledoc """
  The properties of the Page. The page will inherit properties from the parent page. Depending on the page type the hierarchy is defined in either SlideProperties or LayoutProperties.

  ## Attributes

  *   `colorScheme` (*type:* `GoogleApi.Slides.V1.Model.ColorScheme.t`, *default:* `nil`) - The color scheme of the page. If unset, the color scheme is inherited from a parent page. If the page has no parent, the color scheme uses a default Slides color scheme, matching the defaults in the Slides editor. Only the concrete colors of the first 12 ThemeColorTypes are editable. In addition, only the color scheme on `Master` pages can be updated. To update the field, a color scheme containing mappings from all the first 12 ThemeColorTypes to their concrete colors must be provided. Colors for the remaining ThemeColorTypes will be ignored.
  *   `pageBackgroundFill` (*type:* `GoogleApi.Slides.V1.Model.PageBackgroundFill.t`, *default:* `nil`) - The background fill of the page. If unset, the background fill is inherited from a parent page if it exists. If the page has no parent, then the background fill defaults to the corresponding fill in the Slides editor.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :colorScheme => GoogleApi.Slides.V1.Model.ColorScheme.t() | nil,
          :pageBackgroundFill => GoogleApi.Slides.V1.Model.PageBackgroundFill.t() | nil
        }

  field(:colorScheme, as: GoogleApi.Slides.V1.Model.ColorScheme)
  field(:pageBackgroundFill, as: GoogleApi.Slides.V1.Model.PageBackgroundFill)
end

defimpl Poison.Decoder, for: GoogleApi.Slides.V1.Model.PageProperties do
  def decode(value, options) do
    GoogleApi.Slides.V1.Model.PageProperties.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Slides.V1.Model.PageProperties do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
