# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Slides.V1.Model.Range do
  @moduledoc """
  Specifies a contiguous range of an indexed collection, such as characters in text.

  ## Attributes

  *   `endIndex` (*type:* `integer()`, *default:* `nil`) - The optional zero-based index of the end of the collection. Required for `FIXED_RANGE` ranges.
  *   `startIndex` (*type:* `integer()`, *default:* `nil`) - The optional zero-based index of the beginning of the collection. Required for `FIXED_RANGE` and `FROM_START_INDEX` ranges.
  *   `type` (*type:* `String.t`, *default:* `nil`) - The type of range.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :endIndex => integer() | nil,
          :startIndex => integer() | nil,
          :type => String.t() | nil
        }

  field(:endIndex)
  field(:startIndex)
  field(:type)
end

defimpl Poison.Decoder, for: GoogleApi.Slides.V1.Model.Range do
  def decode(value, options) do
    GoogleApi.Slides.V1.Model.Range.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Slides.V1.Model.Range do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
