# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Slides.V1.Model.ReplaceAllTextRequest do
  @moduledoc """
  Replaces all instances of text matching a criteria with replace text.

  ## Attributes

  *   `containsText` (*type:* `GoogleApi.Slides.V1.Model.SubstringMatchCriteria.t`, *default:* `nil`) - Finds text in a shape matching this substring.
  *   `pageObjectIds` (*type:* `list(String.t)`, *default:* `nil`) - If non-empty, limits the matches to page elements only on the given pages. Returns a 400 bad request error if given the page object ID of a notes master, or if a page with that object ID doesn't exist in the presentation.
  *   `replaceText` (*type:* `String.t`, *default:* `nil`) - The text that will replace the matched text.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :containsText => GoogleApi.Slides.V1.Model.SubstringMatchCriteria.t() | nil,
          :pageObjectIds => list(String.t()) | nil,
          :replaceText => String.t() | nil
        }

  field(:containsText, as: GoogleApi.Slides.V1.Model.SubstringMatchCriteria)
  field(:pageObjectIds, type: :list)
  field(:replaceText)
end

defimpl Poison.Decoder, for: GoogleApi.Slides.V1.Model.ReplaceAllTextRequest do
  def decode(value, options) do
    GoogleApi.Slides.V1.Model.ReplaceAllTextRequest.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Slides.V1.Model.ReplaceAllTextRequest do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
