# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Slides.V1.Model.ReplaceImageRequest do
  @moduledoc """
  Replaces an existing image with a new image. Replacing an image removes some image effects from the existing image.

  ## Attributes

  *   `imageObjectId` (*type:* `String.t`, *default:* `nil`) - The ID of the existing image that will be replaced. The ID can be retrieved from the response of a get request.
  *   `imageReplaceMethod` (*type:* `String.t`, *default:* `nil`) - The replacement method.
  *   `url` (*type:* `String.t`, *default:* `nil`) - The image URL. The image is fetched once at insertion time and a copy is stored for display inside the presentation. Images must be less than 50MB, cannot exceed 25 megapixels, and must be in PNG, JPEG, or GIF format. The provided URL can't surpass 2 KB in length. The URL is saved with the image, and exposed through the Image.source_url field.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :imageObjectId => String.t() | nil,
          :imageReplaceMethod => String.t() | nil,
          :url => String.t() | nil
        }

  field(:imageObjectId)
  field(:imageReplaceMethod)
  field(:url)
end

defimpl Poison.Decoder, for: GoogleApi.Slides.V1.Model.ReplaceImageRequest do
  def decode(value, options) do
    GoogleApi.Slides.V1.Model.ReplaceImageRequest.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Slides.V1.Model.ReplaceImageRequest do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
