# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Slides.V1.Model.RgbColor do
  @moduledoc """
  An RGB color.

  ## Attributes

  *   `blue` (*type:* `number()`, *default:* `nil`) - The blue component of the color, from 0.0 to 1.0.
  *   `green` (*type:* `number()`, *default:* `nil`) - The green component of the color, from 0.0 to 1.0.
  *   `red` (*type:* `number()`, *default:* `nil`) - The red component of the color, from 0.0 to 1.0.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :blue => number() | nil,
          :green => number() | nil,
          :red => number() | nil
        }

  field(:blue)
  field(:green)
  field(:red)
end

defimpl Poison.Decoder, for: GoogleApi.Slides.V1.Model.RgbColor do
  def decode(value, options) do
    GoogleApi.Slides.V1.Model.RgbColor.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Slides.V1.Model.RgbColor do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
