# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Slides.V1.Model.Shape do
  @moduledoc """
  A PageElement kind representing a generic shape that does not have a more specific classification.

  ## Attributes

  *   `placeholder` (*type:* `GoogleApi.Slides.V1.Model.Placeholder.t`, *default:* `nil`) - Placeholders are page elements that inherit from corresponding placeholders on layouts and masters. If set, the shape is a placeholder shape and any inherited properties can be resolved by looking at the parent placeholder identified by the Placeholder.parent_object_id field.
  *   `shapeProperties` (*type:* `GoogleApi.Slides.V1.Model.ShapeProperties.t`, *default:* `nil`) - The properties of the shape.
  *   `shapeType` (*type:* `String.t`, *default:* `nil`) - The type of the shape.
  *   `text` (*type:* `GoogleApi.Slides.V1.Model.TextContent.t`, *default:* `nil`) - The text content of the shape.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :placeholder => GoogleApi.Slides.V1.Model.Placeholder.t() | nil,
          :shapeProperties => GoogleApi.Slides.V1.Model.ShapeProperties.t() | nil,
          :shapeType => String.t() | nil,
          :text => GoogleApi.Slides.V1.Model.TextContent.t() | nil
        }

  field(:placeholder, as: GoogleApi.Slides.V1.Model.Placeholder)
  field(:shapeProperties, as: GoogleApi.Slides.V1.Model.ShapeProperties)
  field(:shapeType)
  field(:text, as: GoogleApi.Slides.V1.Model.TextContent)
end

defimpl Poison.Decoder, for: GoogleApi.Slides.V1.Model.Shape do
  def decode(value, options) do
    GoogleApi.Slides.V1.Model.Shape.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Slides.V1.Model.Shape do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
