# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Slides.V1.Model.TableBorderCell do
  @moduledoc """
  The properties of each border cell.

  ## Attributes

  *   `location` (*type:* `GoogleApi.Slides.V1.Model.TableCellLocation.t`, *default:* `nil`) - The location of the border within the border table.
  *   `tableBorderProperties` (*type:* `GoogleApi.Slides.V1.Model.TableBorderProperties.t`, *default:* `nil`) - The border properties.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :location => GoogleApi.Slides.V1.Model.TableCellLocation.t() | nil,
          :tableBorderProperties => GoogleApi.Slides.V1.Model.TableBorderProperties.t() | nil
        }

  field(:location, as: GoogleApi.Slides.V1.Model.TableCellLocation)
  field(:tableBorderProperties, as: GoogleApi.Slides.V1.Model.TableBorderProperties)
end

defimpl Poison.Decoder, for: GoogleApi.Slides.V1.Model.TableBorderCell do
  def decode(value, options) do
    GoogleApi.Slides.V1.Model.TableBorderCell.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Slides.V1.Model.TableBorderCell do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
