# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Slides.V1.Model.TableCell do
  @moduledoc """
  Properties and contents of each table cell.

  ## Attributes

  *   `columnSpan` (*type:* `integer()`, *default:* `nil`) - Column span of the cell.
  *   `location` (*type:* `GoogleApi.Slides.V1.Model.TableCellLocation.t`, *default:* `nil`) - The location of the cell within the table.
  *   `rowSpan` (*type:* `integer()`, *default:* `nil`) - Row span of the cell.
  *   `tableCellProperties` (*type:* `GoogleApi.Slides.V1.Model.TableCellProperties.t`, *default:* `nil`) - The properties of the table cell.
  *   `text` (*type:* `GoogleApi.Slides.V1.Model.TextContent.t`, *default:* `nil`) - The text content of the cell.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :columnSpan => integer() | nil,
          :location => GoogleApi.Slides.V1.Model.TableCellLocation.t() | nil,
          :rowSpan => integer() | nil,
          :tableCellProperties => GoogleApi.Slides.V1.Model.TableCellProperties.t() | nil,
          :text => GoogleApi.Slides.V1.Model.TextContent.t() | nil
        }

  field(:columnSpan)
  field(:location, as: GoogleApi.Slides.V1.Model.TableCellLocation)
  field(:rowSpan)
  field(:tableCellProperties, as: GoogleApi.Slides.V1.Model.TableCellProperties)
  field(:text, as: GoogleApi.Slides.V1.Model.TextContent)
end

defimpl Poison.Decoder, for: GoogleApi.Slides.V1.Model.TableCell do
  def decode(value, options) do
    GoogleApi.Slides.V1.Model.TableCell.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Slides.V1.Model.TableCell do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
