# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Slides.V1.Model.TableRow do
  @moduledoc """
  Properties and contents of each row in a table.

  ## Attributes

  *   `rowHeight` (*type:* `GoogleApi.Slides.V1.Model.Dimension.t`, *default:* `nil`) - Height of a row.
  *   `tableCells` (*type:* `list(GoogleApi.Slides.V1.Model.TableCell.t)`, *default:* `nil`) - Properties and contents of each cell. Cells that span multiple columns are represented only once with a column_span greater than 1. As a result, the length of this collection does not always match the number of columns of the entire table.
  *   `tableRowProperties` (*type:* `GoogleApi.Slides.V1.Model.TableRowProperties.t`, *default:* `nil`) - Properties of the row.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :rowHeight => GoogleApi.Slides.V1.Model.Dimension.t() | nil,
          :tableCells => list(GoogleApi.Slides.V1.Model.TableCell.t()) | nil,
          :tableRowProperties => GoogleApi.Slides.V1.Model.TableRowProperties.t() | nil
        }

  field(:rowHeight, as: GoogleApi.Slides.V1.Model.Dimension)
  field(:tableCells, as: GoogleApi.Slides.V1.Model.TableCell, type: :list)
  field(:tableRowProperties, as: GoogleApi.Slides.V1.Model.TableRowProperties)
end

defimpl Poison.Decoder, for: GoogleApi.Slides.V1.Model.TableRow do
  def decode(value, options) do
    GoogleApi.Slides.V1.Model.TableRow.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Slides.V1.Model.TableRow do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
