# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Slides.V1.Model.TextRun do
  @moduledoc """
  A TextElement kind that represents a run of text that all has the same styling.

  ## Attributes

  *   `content` (*type:* `String.t`, *default:* `nil`) - The text of this run.
  *   `style` (*type:* `GoogleApi.Slides.V1.Model.TextStyle.t`, *default:* `nil`) - The styling applied to this run.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :content => String.t() | nil,
          :style => GoogleApi.Slides.V1.Model.TextStyle.t() | nil
        }

  field(:content)
  field(:style, as: GoogleApi.Slides.V1.Model.TextStyle)
end

defimpl Poison.Decoder, for: GoogleApi.Slides.V1.Model.TextRun do
  def decode(value, options) do
    GoogleApi.Slides.V1.Model.TextRun.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Slides.V1.Model.TextRun do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
