# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Slides.V1.Model.UngroupObjectsRequest do
  @moduledoc """
  Ungroups objects, such as groups.

  ## Attributes

  *   `objectIds` (*type:* `list(String.t)`, *default:* `nil`) - The object IDs of the objects to ungroup. Only groups that are not inside other groups can be ungrouped. All the groups should be on the same page. The group itself is deleted. The visual sizes and positions of all the children are preserved.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :objectIds => list(String.t()) | nil
        }

  field(:objectIds, type: :list)
end

defimpl Poison.Decoder, for: GoogleApi.Slides.V1.Model.UngroupObjectsRequest do
  def decode(value, options) do
    GoogleApi.Slides.V1.Model.UngroupObjectsRequest.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Slides.V1.Model.UngroupObjectsRequest do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
