# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Slides.V1.Model.UpdateLineCategoryRequest do
  @moduledoc """
  Updates the category of a line.

  ## Attributes

  *   `lineCategory` (*type:* `String.t`, *default:* `nil`) - The line category to update to. The exact line type is determined based on the category to update to and how it's routed to connect to other page elements.
  *   `objectId` (*type:* `String.t`, *default:* `nil`) - The object ID of the line the update is applied to. Only a line with a category indicating it is a "connector" can be updated. The line may be rerouted after updating its category.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :lineCategory => String.t() | nil,
          :objectId => String.t() | nil
        }

  field(:lineCategory)
  field(:objectId)
end

defimpl Poison.Decoder, for: GoogleApi.Slides.V1.Model.UpdateLineCategoryRequest do
  def decode(value, options) do
    GoogleApi.Slides.V1.Model.UpdateLineCategoryRequest.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Slides.V1.Model.UpdateLineCategoryRequest do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
