# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Slides.V1.Model.UpdatePageElementAltTextRequest do
  @moduledoc """
  Updates the alt text title and/or description of a page element.

  ## Attributes

  *   `description` (*type:* `String.t`, *default:* `nil`) - The updated alt text description of the page element. If unset the existing value will be maintained. The description is exposed to screen readers and other accessibility interfaces. Only use human readable values related to the content of the page element.
  *   `objectId` (*type:* `String.t`, *default:* `nil`) - The object ID of the page element the updates are applied to.
  *   `title` (*type:* `String.t`, *default:* `nil`) - The updated alt text title of the page element. If unset the existing value will be maintained. The title is exposed to screen readers and other accessibility interfaces. Only use human readable values related to the content of the page element.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :description => String.t() | nil,
          :objectId => String.t() | nil,
          :title => String.t() | nil
        }

  field(:description)
  field(:objectId)
  field(:title)
end

defimpl Poison.Decoder, for: GoogleApi.Slides.V1.Model.UpdatePageElementAltTextRequest do
  def decode(value, options) do
    GoogleApi.Slides.V1.Model.UpdatePageElementAltTextRequest.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Slides.V1.Model.UpdatePageElementAltTextRequest do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
