# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Slides.V1.Model.UpdatePageElementTransformRequest do
  @moduledoc """
  Updates the transform of a page element. Updating the transform of a group will change the absolute transform of the page elements in that group, which can change their visual appearance. See the documentation for PageElement.transform for more details.

  ## Attributes

  *   `applyMode` (*type:* `String.t`, *default:* `nil`) - The apply mode of the transform update.
  *   `objectId` (*type:* `String.t`, *default:* `nil`) - The object ID of the page element to update.
  *   `transform` (*type:* `GoogleApi.Slides.V1.Model.AffineTransform.t`, *default:* `nil`) - The input transform matrix used to update the page element.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :applyMode => String.t() | nil,
          :objectId => String.t() | nil,
          :transform => GoogleApi.Slides.V1.Model.AffineTransform.t() | nil
        }

  field(:applyMode)
  field(:objectId)
  field(:transform, as: GoogleApi.Slides.V1.Model.AffineTransform)
end

defimpl Poison.Decoder, for: GoogleApi.Slides.V1.Model.UpdatePageElementTransformRequest do
  def decode(value, options) do
    GoogleApi.Slides.V1.Model.UpdatePageElementTransformRequest.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Slides.V1.Model.UpdatePageElementTransformRequest do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
