# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Slides.V1.Model.UpdatePageElementsZOrderRequest do
  @moduledoc """
  Updates the Z-order of page elements. Z-order is an ordering of the elements on the page from back to front. The page element in the front may cover the elements that are behind it.

  ## Attributes

  *   `operation` (*type:* `String.t`, *default:* `nil`) - The Z-order operation to apply on the page elements. When applying the operation on multiple page elements, the relative Z-orders within these page elements before the operation is maintained.
  *   `pageElementObjectIds` (*type:* `list(String.t)`, *default:* `nil`) - The object IDs of the page elements to update. All the page elements must be on the same page and must not be grouped.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :operation => String.t() | nil,
          :pageElementObjectIds => list(String.t()) | nil
        }

  field(:operation)
  field(:pageElementObjectIds, type: :list)
end

defimpl Poison.Decoder, for: GoogleApi.Slides.V1.Model.UpdatePageElementsZOrderRequest do
  def decode(value, options) do
    GoogleApi.Slides.V1.Model.UpdatePageElementsZOrderRequest.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Slides.V1.Model.UpdatePageElementsZOrderRequest do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
