# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Slides.V1.Model.UpdatePagePropertiesRequest do
  @moduledoc """
  Updates the properties of a Page.

  ## Attributes

  *   `fields` (*type:* `String.t`, *default:* `nil`) - The fields that should be updated. At least one field must be specified. The root `pageProperties` is implied and should not be specified. A single `"*"` can be used as short-hand for listing every field. For example to update the page background solid fill color, set `fields` to `"pageBackgroundFill.solidFill.color"`. To reset a property to its default value, include its field name in the field mask but leave the field itself unset.
  *   `objectId` (*type:* `String.t`, *default:* `nil`) - The object ID of the page the update is applied to.
  *   `pageProperties` (*type:* `GoogleApi.Slides.V1.Model.PageProperties.t`, *default:* `nil`) - The page properties to update.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :fields => String.t() | nil,
          :objectId => String.t() | nil,
          :pageProperties => GoogleApi.Slides.V1.Model.PageProperties.t() | nil
        }

  field(:fields)
  field(:objectId)
  field(:pageProperties, as: GoogleApi.Slides.V1.Model.PageProperties)
end

defimpl Poison.Decoder, for: GoogleApi.Slides.V1.Model.UpdatePagePropertiesRequest do
  def decode(value, options) do
    GoogleApi.Slides.V1.Model.UpdatePagePropertiesRequest.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Slides.V1.Model.UpdatePagePropertiesRequest do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
