# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Slides.V1.Model.UpdateSlidePropertiesRequest do
  @moduledoc """
  Updates the properties of a Slide.

  ## Attributes

  *   `fields` (*type:* `String.t`, *default:* `nil`) - The fields that should be updated. At least one field must be specified. The root 'slideProperties' is implied and should not be specified. A single `"*"` can be used as short-hand for listing every field. For example to update whether a slide is skipped, set `fields` to `"isSkipped"`. To reset a property to its default value, include its field name in the field mask but leave the field itself unset.
  *   `objectId` (*type:* `String.t`, *default:* `nil`) - The object ID of the slide the update is applied to.
  *   `slideProperties` (*type:* `GoogleApi.Slides.V1.Model.SlideProperties.t`, *default:* `nil`) - The slide properties to update.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :fields => String.t() | nil,
          :objectId => String.t() | nil,
          :slideProperties => GoogleApi.Slides.V1.Model.SlideProperties.t() | nil
        }

  field(:fields)
  field(:objectId)
  field(:slideProperties, as: GoogleApi.Slides.V1.Model.SlideProperties)
end

defimpl Poison.Decoder, for: GoogleApi.Slides.V1.Model.UpdateSlidePropertiesRequest do
  def decode(value, options) do
    GoogleApi.Slides.V1.Model.UpdateSlidePropertiesRequest.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Slides.V1.Model.UpdateSlidePropertiesRequest do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
