# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Slides.V1.Model.UpdateTableBorderPropertiesRequest do
  @moduledoc """
  Updates the properties of the table borders in a Table.

  ## Attributes

  *   `borderPosition` (*type:* `String.t`, *default:* `nil`) - The border position in the table range the updates should apply to. If a border position is not specified, the updates will apply to all borders in the table range.
  *   `fields` (*type:* `String.t`, *default:* `nil`) - The fields that should be updated. At least one field must be specified. The root `tableBorderProperties` is implied and should not be specified. A single `"*"` can be used as short-hand for listing every field. For example to update the table border solid fill color, set `fields` to `"tableBorderFill.solidFill.color"`. To reset a property to its default value, include its field name in the field mask but leave the field itself unset.
  *   `objectId` (*type:* `String.t`, *default:* `nil`) - The object ID of the table.
  *   `tableBorderProperties` (*type:* `GoogleApi.Slides.V1.Model.TableBorderProperties.t`, *default:* `nil`) - The table border properties to update.
  *   `tableRange` (*type:* `GoogleApi.Slides.V1.Model.TableRange.t`, *default:* `nil`) - The table range representing the subset of the table to which the updates are applied. If a table range is not specified, the updates will apply to the entire table.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :borderPosition => String.t() | nil,
          :fields => String.t() | nil,
          :objectId => String.t() | nil,
          :tableBorderProperties => GoogleApi.Slides.V1.Model.TableBorderProperties.t() | nil,
          :tableRange => GoogleApi.Slides.V1.Model.TableRange.t() | nil
        }

  field(:borderPosition)
  field(:fields)
  field(:objectId)
  field(:tableBorderProperties, as: GoogleApi.Slides.V1.Model.TableBorderProperties)
  field(:tableRange, as: GoogleApi.Slides.V1.Model.TableRange)
end

defimpl Poison.Decoder, for: GoogleApi.Slides.V1.Model.UpdateTableBorderPropertiesRequest do
  def decode(value, options) do
    GoogleApi.Slides.V1.Model.UpdateTableBorderPropertiesRequest.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Slides.V1.Model.UpdateTableBorderPropertiesRequest do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
