# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Slides.V1.Model.UpdateTableCellPropertiesRequest do
  @moduledoc """
  Update the properties of a TableCell.

  ## Attributes

  *   `fields` (*type:* `String.t`, *default:* `nil`) - The fields that should be updated. At least one field must be specified. The root `tableCellProperties` is implied and should not be specified. A single `"*"` can be used as short-hand for listing every field. For example to update the table cell background solid fill color, set `fields` to `"tableCellBackgroundFill.solidFill.color"`. To reset a property to its default value, include its field name in the field mask but leave the field itself unset.
  *   `objectId` (*type:* `String.t`, *default:* `nil`) - The object ID of the table.
  *   `tableCellProperties` (*type:* `GoogleApi.Slides.V1.Model.TableCellProperties.t`, *default:* `nil`) - The table cell properties to update.
  *   `tableRange` (*type:* `GoogleApi.Slides.V1.Model.TableRange.t`, *default:* `nil`) - The table range representing the subset of the table to which the updates are applied. If a table range is not specified, the updates will apply to the entire table.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :fields => String.t() | nil,
          :objectId => String.t() | nil,
          :tableCellProperties => GoogleApi.Slides.V1.Model.TableCellProperties.t() | nil,
          :tableRange => GoogleApi.Slides.V1.Model.TableRange.t() | nil
        }

  field(:fields)
  field(:objectId)
  field(:tableCellProperties, as: GoogleApi.Slides.V1.Model.TableCellProperties)
  field(:tableRange, as: GoogleApi.Slides.V1.Model.TableRange)
end

defimpl Poison.Decoder, for: GoogleApi.Slides.V1.Model.UpdateTableCellPropertiesRequest do
  def decode(value, options) do
    GoogleApi.Slides.V1.Model.UpdateTableCellPropertiesRequest.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Slides.V1.Model.UpdateTableCellPropertiesRequest do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
