# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Slides.V1.Model.UpdateTableColumnPropertiesRequest do
  @moduledoc """
  Updates the properties of a Table column.

  ## Attributes

  *   `columnIndices` (*type:* `list(integer())`, *default:* `nil`) - The list of zero-based indices specifying which columns to update. If no indices are provided, all columns in the table will be updated.
  *   `fields` (*type:* `String.t`, *default:* `nil`) - The fields that should be updated. At least one field must be specified. The root `tableColumnProperties` is implied and should not be specified. A single `"*"` can be used as short-hand for listing every field. For example to update the column width, set `fields` to `"column_width"`. If '"column_width"' is included in the field mask but the property is left unset, the column width will default to 406,400 EMU (32 points).
  *   `objectId` (*type:* `String.t`, *default:* `nil`) - The object ID of the table.
  *   `tableColumnProperties` (*type:* `GoogleApi.Slides.V1.Model.TableColumnProperties.t`, *default:* `nil`) - The table column properties to update. If the value of `table_column_properties#column_width` in the request is less than 406,400 EMU (32 points), a 400 bad request error is returned.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :columnIndices => list(integer()) | nil,
          :fields => String.t() | nil,
          :objectId => String.t() | nil,
          :tableColumnProperties => GoogleApi.Slides.V1.Model.TableColumnProperties.t() | nil
        }

  field(:columnIndices, type: :list)
  field(:fields)
  field(:objectId)
  field(:tableColumnProperties, as: GoogleApi.Slides.V1.Model.TableColumnProperties)
end

defimpl Poison.Decoder, for: GoogleApi.Slides.V1.Model.UpdateTableColumnPropertiesRequest do
  def decode(value, options) do
    GoogleApi.Slides.V1.Model.UpdateTableColumnPropertiesRequest.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Slides.V1.Model.UpdateTableColumnPropertiesRequest do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
