# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Slides.V1.Model.UpdateTableRowPropertiesRequest do
  @moduledoc """
  Updates the properties of a Table row.

  ## Attributes

  *   `fields` (*type:* `String.t`, *default:* `nil`) - The fields that should be updated. At least one field must be specified. The root `tableRowProperties` is implied and should not be specified. A single `"*"` can be used as short-hand for listing every field. For example to update the minimum row height, set `fields` to `"min_row_height"`. If '"min_row_height"' is included in the field mask but the property is left unset, the minimum row height will default to 0.
  *   `objectId` (*type:* `String.t`, *default:* `nil`) - The object ID of the table.
  *   `rowIndices` (*type:* `list(integer())`, *default:* `nil`) - The list of zero-based indices specifying which rows to update. If no indices are provided, all rows in the table will be updated.
  *   `tableRowProperties` (*type:* `GoogleApi.Slides.V1.Model.TableRowProperties.t`, *default:* `nil`) - The table row properties to update.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :fields => String.t() | nil,
          :objectId => String.t() | nil,
          :rowIndices => list(integer()) | nil,
          :tableRowProperties => GoogleApi.Slides.V1.Model.TableRowProperties.t() | nil
        }

  field(:fields)
  field(:objectId)
  field(:rowIndices, type: :list)
  field(:tableRowProperties, as: GoogleApi.Slides.V1.Model.TableRowProperties)
end

defimpl Poison.Decoder, for: GoogleApi.Slides.V1.Model.UpdateTableRowPropertiesRequest do
  def decode(value, options) do
    GoogleApi.Slides.V1.Model.UpdateTableRowPropertiesRequest.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Slides.V1.Model.UpdateTableRowPropertiesRequest do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
