# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Slides.V1.Model.WeightedFontFamily do
  @moduledoc """
  Represents a font family and weight used to style a TextRun.

  ## Attributes

  *   `fontFamily` (*type:* `String.t`, *default:* `nil`) - The font family of the text. The font family can be any font from the Font menu in Slides or from [Google Fonts] (https://fonts.google.com/). If the font name is unrecognized, the text is rendered in `Arial`.
  *   `weight` (*type:* `integer()`, *default:* `nil`) - The rendered weight of the text. This field can have any value that is a multiple of `100` between `100` and `900`, inclusive. This range corresponds to the numerical values described in the CSS 2.1 Specification, [section 15.6](https://www.w3.org/TR/CSS21/fonts.html#font-boldness), with non-numerical values disallowed. Weights greater than or equal to `700` are considered bold, and weights less than `700`are not bold. The default value is `400` ("normal").
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :fontFamily => String.t() | nil,
          :weight => integer() | nil
        }

  field(:fontFamily)
  field(:weight)
end

defimpl Poison.Decoder, for: GoogleApi.Slides.V1.Model.WeightedFontFamily do
  def decode(value, options) do
    GoogleApi.Slides.V1.Model.WeightedFontFamily.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Slides.V1.Model.WeightedFontFamily do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
